from SDTPF import SDTPF
from Distribution_LoadFlow import DLF
import numpy as np
import opendssdirect as dss
cosimerror = 1
cosimcount = 0

V_a = 1.05
V_b = 1.05
V_c = 1.05
Angle_a = 0
Angle_b = 240
Angle_c = 120
Pl_update = np.array([0.3, 0.3, 0.3])
Ql_update = np.array([0.1, 0.1, 0.1])
a = SDTPF(9)
data = a.compiledata()
b = DLF()

i=0
npts=24
loaddata = np.loadtxt('dailyload.txt')

for i in range(len(loaddata)):
    str = 'set mode=snap loadmult={0}'.format(loaddata[i])
    cosimerror=1
    cosimcount=0

#while i in range(npts):
    while cosimerror >0.000001:
        b.createckt(V_a, V_b, V_c, Angle_a, Angle_b, Angle_c)
        transerror = a.threeseq_solve(*data, Pl_update, Ql_update)
        b.COMPILE('ckt24')

        dss.run_command(str)
        disterror_24 = b.LFTIMESERIES('ckt24')
        b.COMPILE('ckt7')
        dss.run_command(str)
        disterror_7 = b.LFTIMESERIES('ckt7')
        P = disterror_24['Real_Power'] + disterror_7['Real_Power']
        Q = disterror_24['Reactive_Power'] + disterror_7['Reactive_Power']
        V_abs = disterror_24['Interface_Voltage']
        dist_error = np.concatenate((P, Q, V_abs), axis=0)
        m = transerror['error_matrixtrans'] - dist_error
        cosimerror = np.max(np.absolute(m))

        Pdiff = P - transerror['Ploadbus']
        Qdiff = Q - transerror['Qloadbus']

        Pl_update = Pdiff + transerror['Ploadbus']
        Ql_update = Qdiff + transerror['Qloadbus']

        V_a = V_a + (transerror['Va'][5] - V_abs[0])
        V_b = V_b + (transerror['Vb'][5] - V_abs[1])
        V_c = V_c + (transerror['Vc'][5] - V_abs[2])

        Angle_a = transerror['Va_angle'][5]
        Angle_b = transerror['Vb_angle'][5]
        Angle_c = transerror['Vc_angle'][5]
        cosimcount = cosimcount+1

    print('................converged.......................')