import numpy as np
import math
import cmath
import os

def arraymXn(m, n):
    a1 = np.zeros((m, n), dtype=complex)
    return a1

def complexno(a, b):
    b1 = a + 1j*b
    return b1

def admittancedia(nbus, nl, i, j, y0, Tap, s0, Yn, BranchFrom, BranchTo):
    for i in range(nbus):
        for j in range(nl):
            if BranchFrom[j] == i + 1:
                Yn[i, i] = Yn[i, i] + y0[j] / (Tap[j] ** 2) + s0[j]
    for i in range(nbus):
        for j in range(nl):
            if BranchTo[j] == i + 1:
                Yn[i, i] = Yn[i, i] + y0[j] / (Tap[j] ** 2) + s0[j]
    return Yn

def admittanceoffdia(nl, k, y1, Tap, Ym, BranchFrom, BranchTo):
    for k in range(nl):
        Ym[int(BranchFrom[k] - 1), int(BranchTo[k] - 1)] = Ym[int(BranchFrom[k] - 1), int(BranchTo[k] - 1)] - y1[k]/Tap[k]
        Ym[int(BranchTo[k] - 1), int(BranchFrom[k] - 1)] = Ym[int(BranchFrom[k] - 1), int(BranchTo[k] - 1)]
    return Ym

def admittance(nbus, nl, i, j, k, y1, Tap, s0, Yn, BranchFrom, BranchTo):
    admittancedia(nbus, nl, i, j, y1, Tap, s0, Yn, BranchFrom, BranchTo)
    admittanceoffdia(nl, k, y1, Tap, Yn, BranchFrom, BranchTo)
    return Yn

def threephasearr(nl, k, Va, Vb, Vc, pharr):
    for k in range(nl):
        pharr[:, k] = np.array([Va[k], Vb[k], Vc[k]])
    return pharr

def threephasetoseq(nl, k, t, threephasearr, seqarr):
    for k in range(nl):
        seqarr[:, k] = np.dot(t, threephasearr[:, k])
    return seqarr

def removefileifexists(filename):
    try:
        os.remove(filename)
    except OSError as e:
        if e.errno == 'errno.ENOENT':
            raise
